
#include "Graph.h"
#include "common.h"

/*	׷ ʱȭϴ Լ Ű  .	*/
void GraphInit(Graph* pGraph, int VertextCount)
{
	int i;

	pGraph->NumOfEdge = 0;
	pGraph->NumOfVertex = VertextCount;

	pGraph->pVertexList = (Vertex**)malloc(sizeof(Vertex) * pGraph->NumOfVertex);

	for ( i = 0; i < pGraph->NumOfVertex; i++)
		pGraph->pVertexList[i] = NULL;
}

/*	׷  Orign  Dest ߰ϴ Լ	*/
void AddVertex(Graph* pGraph, int Orign, int Dest, int Cost)
{
	/*	߰  Dest .	*/
	Vertex* newVertex = (Vertex*)malloc(sizeof(Vertex));
	newVertex->Dest = Dest;
	newVertex->pNext = NULL;
	newVertex->Cost = Cost;		//	 ߰

	Vertex* pCurVertex = NULL;

	/*	 Orign  Dest ߰ϴ κ	*/
	if (pGraph->pVertexList[Orign] == NULL)
		pGraph->pVertexList[Orign] = newVertex;
	else
	{
		pCurVertex = pGraph->pVertexList[Orign];

		while (pCurVertex->pNext != NULL)	
			pCurVertex = pCurVertex->pNext;

		pCurVertex->pNext = newVertex;
	}
}

/*	׷  ߰ϴ Լ,  Orign  Dest Ѵ.	*/
void AddEdge(Graph* pGraph, int Orign, int Dest, int Cost)
{
	pGraph->NumOfEdge++;

	/*	 Orign Dest 	*/
	AddVertex(pGraph, Orign, Dest, Cost);

	/*	 Dest Orign 	*/
	AddVertex(pGraph, Dest, Orign, Cost);
}

/*	׷   Ѵ Լ	*/
void DisplayEdgeInfo(Graph* pGraph)
{
	int i;
	Vertex* pCurVertex = NULL;

	printf("   =>\t%d\n\n", pGraph->NumOfEdge);

	for ( i = 0; i < pGraph->NumOfVertex; i++)
	{
		if (pGraph->pVertexList[i] == NULL)
			continue;

		printf("%c  =>\t", 'A' + i);

		pCurVertex = pGraph->pVertexList[i];

		while (pCurVertex != NULL)
		{
			printf("%c %d\t", 'A' + pCurVertex->Dest, pCurVertex->Cost);
			pCurVertex = pCurVertex->pNext;
		}
		printf("\n");
	}
}

/*	     ϴ Լ	*/
void RemoveAllVertex(Vertex* pHead)
{
	Vertex* pCurVertex = NULL;
	Vertex* pDelVertex = NULL;

	if (pHead == NULL)
		return;

	pCurVertex = pHead;

	while (pCurVertex != NULL)
	{
		pDelVertex = pCurVertex;
		pCurVertex = pCurVertex->pNext;
		
		free(pDelVertex);
	}
}

/*	׷   ϴ Լ	*/
void DestroyGraph(Graph* pGraph)
{
	int i;

	if (pGraph == NULL)	
		return;
	
	/*	
		pGraph NULL ƴϸ,  Ͱ ִٴ ǹ̸, 
		pGraphȿ ִ pVertexList͸  Ѵ	
	*/
	for ( i = 0; i < pGraph->NumOfVertex; i++)
	{
		/*	NULL̸, ʿǷ,  ̵Ѵ.	*/
		if (pGraph->pVertexList[i] == NULL)
			continue;	

		/*	     	*/
		RemoveAllVertex(pGraph->pVertexList[i]);

		pGraph->pVertexList[i] = NULL;
	}

	/*	    ʱȭ	*/
	pGraph->NumOfEdge = pGraph->NumOfVertex = 0;
}